Bug 11603 - [intel] EDID 1.0 CRT incorrect preferred resolution and size detection
[intel] EDID 1.0 CRT incorrect preferred resolution and size detection
Status: RESOLVED FIXED
Product: xorg
Classification: Unclassified
Component: Driver/intel
unspecified
Other All
: medium normal
Assigned To: Eric Anholt
Xorg Project Team
:
Depends on:
Blocks:
  Show dependency treegraph
 
Reported: 2007-07-14 12:34 UTC by Rui Tiago Matos
Modified: 2007-11-11 17:48 UTC (History)
0 users

See Also:
i915 platform:
i915 features:


Attachments
Xorg log (166.93 KB, text/plain)
2007-07-14 12:35 UTC, Rui Tiago Matos
no flags Details
xorg.conf (731 bytes, text/plain)
2007-07-14 12:36 UTC, Rui Tiago Matos
no flags Details
quirks for funai pm36b (6.96 KB, patch)
2007-08-09 13:32 UTC, Eric Anholt
no flags Details | Splinter Review
xrandr --verbose (6.31 KB, text/plain)
2007-08-10 17:02 UTC, Rui Tiago Matos
no flags Details
new log (169.08 KB, text/plain)
2007-08-10 17:02 UTC, Rui Tiago Matos
no flags Details

Note You need to log in before you can comment on or make changes to this bug.
Description Rui Tiago Matos 2007-07-14 12:34:23 UTC
I get this from xdpyinfo:

screen #0:
  dimensions:    1024x768 pixels (25x22 millimeters)
  resolution:    1040x887 dots per inch

Which is incorrect and makes some apps like emacs go wild with font sizes.

This machine is an intel mac mini running fedora 7 with and intel driver from git commit ff2be3995d33f9e4b7f63b380f166b6168c9b9c6, dated Fri Jul 13 12:47:18 2007. I'm using an almost empty xorg.conf just to force load the 'intel' driver.

The monitor is a somewhat old 15 inch CRT and thus I'm using the DVI <-> VGA adapter.

There's another issue which I should maybe report in another bug: the driver always chooses as default resolution 720x400@70.1 which looks really odd but looking at the X log the monitor seems to return the correct information to the driver about the resolutions it supports. Actually xrandr reports a lot of resolutions which I don't even dare try fearing the monitor to fry:

Screen 0: minimum 320 x 200, current 1024 x 768, maximum 1360 x 1360
VGA connected 1024x768+0+0 (normal left inverted right) 25mm x 19mm
   1360x768       59.8     60.0  
   1280x800       60.0  
   1152x864       60.0  
   1280x768       60.0  
   1280x720       60.0  
   1024x768       84.9     75.1*    70.1     60.0  
   800x600        84.9     75.0     60.3  
   720x540        69.9  
   640x480        80.6     84.6     75.0     60.0     59.9  
   720x400        70.1  
TMDS-1 connected (normal left inverted right)
   1360x768       59.8     60.0  
   1280x800       60.0  
   1152x864       60.0  
   1280x768       60.0  
   1280x720       60.0  
   1024x768       60.0  
   800x600        60.3  
   640x480        59.9  
TV disconnected (normal left inverted right)

The mode I'm running is what I'm using in mac os x which actually just allows me to choose from 3 resolutions:

640x480
800x600
1024x768

I'm attaching the X log, thanks for looking at this!
Comment 1 Rui Tiago Matos 2007-07-14 12:35:55 UTC
Created attachment 10725 [details]
Xorg log
Comment 2 Rui Tiago Matos 2007-07-14 12:36:33 UTC
Created attachment 10726 [details]
xorg.conf
Comment 3 Eric Anholt 2007-08-08 15:29:56 UTC
Is 1024x768@60hz the preferred mode for this monitor?  Can you give me a product name to associate with it?
Comment 4 Rui Tiago Matos 2007-08-08 15:54:02 UTC
(In reply to comment #3)
> Is 1024x768@60hz the preferred mode for this monitor?  Can you give me a
> product name to associate with it?
> 

Preferred as in "written in the box or manual"? That I don't know since I lost those some years ago... But the mode I always used is 1024x768@75 so I'd like that to be the preferred :-)

About the name. On the back it says it's made by "FUNAI Electric Company of Taiwan" and the model number is PM36B.

Will the driver be able to detect the correct physical size and set DPI to sane values?

Thanks!
Comment 5 Eric Anholt 2007-08-09 13:32:01 UTC
Created attachment 11066 [details] [review]
quirks for funai pm36b

Could you test the attached patch for the X Server to add quirks for this monitor?  I'm hoping it fixes both the physical size detection and the initial mode selection.
Comment 6 Rui Tiago Matos 2007-08-09 18:05:20 UTC
(In reply to comment #5)
> Created an attachment (id=11066) [details]
> quirks for funai pm36b
> 
> Could you test the attached patch for the X Server to add quirks for this
> monitor?  I'm hoping it fixes both the physical size detection and the initial
> mode selection.

Applied the patch to fedora's current X server (1.3.0.0-9.fc7), rebuilt the rpm and yea, it's working.

Just a tiny bit which is still wrong: the auto selected mode is 1024x768@70 and not 75. Else it's great now.
Comment 7 Rui Tiago Matos 2007-08-10 07:07:56 UTC
> Else it's great now.

Well, actually it is not. I had changed gdm to start the server with "-dpi 96" and forgot to change it... After removing that and with this patch applied I get this:

$ xdpyinfo
...
screen #0:
  dimensions:    1024x768 pixels (25x19 millimeters)
  resolution:    1040x1027 dots per inch
...
Comment 8 Eric Anholt 2007-08-10 09:49:56 UTC
Could you include the output of xrandr --verbose?
Comment 9 Eric Anholt 2007-08-10 10:22:04 UTC
And the new log, too.
Comment 10 Rui Tiago Matos 2007-08-10 17:02:12 UTC
Created attachment 11080 [details]
xrandr --verbose
Comment 11 Rui Tiago Matos 2007-08-10 17:02:53 UTC
Created attachment 11081 [details]
new log
Comment 12 Rui Tiago Matos 2007-08-10 17:05:46 UTC
(In reply to comment #9)
> And the new log, too.
> 

done. fyi, i'm using 1024x768@75 because i set gnome to do the change on login, because gdm comes up @70hz.
Comment 13 Eric Anholt 2007-10-11 16:58:48 UTC
Please re-test with the current x server with a plan Xorg startup (not gdm), which has a variant of this patch committed.  And new log if it fails.
Comment 14 Gordon Jin 2007-11-11 17:48:49 UTC
I'm assuming this is fixed as feedback timeout. Please reopen if it still exists with the new server code.